#
#    Copyright (C) 2006-2012  Corporation of Balclutha. All rights Reserved.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
#    AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
#    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
#    ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
#    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
#    CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE
#    GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
#    HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
#    LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
#    OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

from zope.interface import Interface


class IBastionLedger(Interface):
    """
    marker for a BastionLedger - collection of ledger, orderbook, etc etc
    """
    pass


class ILedger(Interface):
    """
    definition(s) of what a ledger *must* support
    """
    def createTransaction(effective, title=''):
        """
        return a *transaction* derivative for this type, persisted in the ledger
        this obviates the need to know about txn sub-types, numbers etc etc
        """

    def createAccount(title, accno, type):
        """
        return an *account* derivative for this type, persisted in the ledger
        """


class IBLLedger(Interface):
    """
    marks the special 'general ledger' ledger
    """


class ISubsidiaryLedger(IBLLedger):
    """
    marks a subsidiary/journal ledger
    """


class IForecast(Interface):
    """
    a future-dated list of balances for account(s) within a ledger
    """
