## Controller Python Script "blperiod_end"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind state=state
##bind subpath=traverse_subpath
##parameters=effective=None,eodeffective=None,rerun=False
##title=perform period-end processing for ledger
##
request = context.REQUEST
from Products.BastionLedger.utils import floor_date
from Products.CMFPlone.utils import transaction_note

# place TZ in effective
if request.has_key('form.button.Balances'):
    context.manage_recalculateBalances()
    context.plone_utils.addPortalMessage('Recalculated Balances')
elif request.has_key('form.button.Controls'):
    context.manage_recalculateControls()
    context.plone_utils.addPortalMessage('Recalculated control accounts')
elif request.has_key('form.button.Recatalog'):
    context.manage_fixupCatalogs('Fixed up catalogs')
    context.plone_utils.addPortalMessage('Recataloged ledger')
elif request.has_key('form.button.Verify'):
    context.manage_verify()
else:
    effective = effective or eodeffective

    if request.has_key('form.button.Reports'):
        context.manage_periodEndReports(effective)
        context.plone_utils.addPortalMessage('Rerun reports for %s' % context.toLocalizedTime(effective))
    elif request.has_key('form.button.Run') or request.has_key('form.button.Rerun'):
        context.manage_periodEnd(effective, force=request.has_key('form.button.Rerun'))
        context.plone_utils.addPortalMessage('Ran period end for %s' % context.toLocalizedTime(effective))
    elif request.has_key('form.button.Reset'):
        context.portal_bastionledger.periodend_tool.manage_reset(context)
        transaction_note('Reset period ends for %s at %s' % (context.title_or_id(), context.absolute_url()))
        context.plone_utils.addPortalMessage('Reinitialized all period end processing')
    elif request.has_key('form.button.EOD'):
        days = context.manage_dailyEnd(eodeffective)
        context.plone_utils.addPortalMessage('Rolled over %i days' % days)
return state

