#
#    Copyright (C) 2002-2006  Corporation of Balclutha. All rights Reserved.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
#    AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
#    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
#    ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
#    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
#    CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE
#    GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
#    HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
#    LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
#    OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

from unittest import TestSuite, makeSuite

from Testing import ZopeTestCase  # this fixes up PYTHONPATH :)
from Products.BastionLedger.tests import LedgerTestCase

from Products.BastionBanking.ZCurrency import ZCurrency


class TestLedgerTool(LedgerTestCase.LedgerTestCase):

    def testIt(self):
        # the big all-in test ...
        self.assertTrue('portal_bastionledger' in self.portal.objectIds())

    def testTaxCodes(self):
        lt = self.portal.portal_bastionledger
        sales_tax = lt.sales_tax
        self.assertEqual(sales_tax.taxCodes(), ['A'])
        self.assertEqual(lt.taxCodes(include_group=True),
                         ['company_tax/A', 'personal_tax/A', 'sales_tax/A'])


def test_suite():
    suite = TestSuite()
    suite.addTest(makeSuite(TestLedgerTool))
    return suite
